#include <stdio.h>
#include <stdlib.h>
#include <math.h>


double F(double ut, int c1, int c2, int Lmin, int Lmax, float m)
{
	int x;
	double a1, a2, aa1, aa2, b1, b2, A, B, C;
	double p, p1, p2, pp1, pp2;
	double temp, temp1, temp2;
	double F, F1, F2, FB, FC;
	
	
	
	a1=a2=aa1=aa2=1;
	for (x=0; x<6; x++)  a1 *= 0.25;
	for (x=0; x<4; x++)  a2 *= 0.25;
	for (x=0; x<6+c1; x++)  aa1 *= 0.25;
	for (x=0; x<4+c2; x++)  aa2 *= 0.25;
	

	p = 0.25*(1+3*exp(-ut*4/3));
	
	p1 = p*p*p*p*p*p;
	p2 = p*p*p*p;
	pp1 = 1;
	pp2 = 1;
	for (x=0; x<c1+6; x++)  pp1 *= p;
	for (x=0; x<c2+4; x++)  pp2 *= p;
	b1 = a1*(1-p1);
	b2 = a2*(1-p2);
	
	A = (1-a1)*(1-a2);
	
	temp=temp1=temp2=1;
	for (x=Lmin; x<=Lmax; x++)  temp *= A*(1-b1)*(1-b1)*(1-b2)*(1-b2);
	for (x=Lmin; x<=Lmax; x++)  temp1 *= A;
	for (x=Lmin; x<=Lmax; x++)  temp2 *= A*A;
	
	B = (1-temp)/(1-temp1);
	C = (1-A)*(1-temp2)/(1-temp1)/(1-temp1)/(1+A);
	
	
	
	F1 = (1-A)*pp1*pp1*pp1*pp1;
	F1 = F1/(1-A*(1-b1)*(1-b1)*(1-b2)*(1-b2));
	for (x=0; x<2*Lmin-10; x++)  F1 *= 1-b1;
	for (x=0; x<2*Lmin-6; x++)   F1 *= 1-b2; 
	
	F2 = (1-A)*pp1*pp1*pp2*pp2;
	F2 = F2/(1-A*(1-b1)*(1-b1)*(1-b2)*(1-b2));
	for (x=0; x<2*Lmin-10; x++)  F2 *= 1-b1;
	for (x=0; x<2*Lmin-6; x++)   F2 *= 1-b2; 
	
	F = (aa1*F1 + 2*aa2*F2)/(aa1 + 2*aa2);
	
	FB = F*B;
	FC = (1-FB)*m*C+FB;
	
	/*printf ("a1=%f\na2=%f\naa1=%f\naa2=%f\n", a1, a2, aa1, aa2);
	printf ("p1=%f\np2=%f\npp1=%f\npp2=%f\n", p1, p2, pp1, pp2);
	printf ("b1=%f\nb2=%f\nA=%f\nB=%f\nC=%f\n", b1, b2, A, B, C);
	printf ("F1=%f\nF2=%f\n", F1, F2);
	printf ("F=%f\nF(B)=%f\nF(C)=%f\n", F, FB, FC);*/
	
	/*printf ("ut,F,FB,FC(%f)=\t%f\t%f\t%f\t%f\n", m, ut, F, FB, FC);*/
	
	return FC;
}

main (void)
{
	double x, temp, f;
	int c1, c2, Lmin, Lmax;
	float m, ff;
	
	
	printf ("Number of selective bases (EcoRI-primer): ");
	scanf ("%d", &c1);
	printf ("Number of selective bases (MseI-primer): ");
	scanf ("%d", &c2);
	printf ("Lmin: ");
	scanf ("%d", &Lmin);
	printf ("Lmax: ");
	scanf ("%d", &Lmax);
	printf ("Average number of bands (m): ");
	scanf ("%f", &m);
	printf ("Proportion of shared bands (F): ");
	scanf ("%f", &ff);
	printf ("\n");
	
	if (Lmax<Lmin)  {printf ("ERROR because Lmax<Lmin\n");  exit(1);}
	if (ff<0)  {printf ("ERROR because F<0\n");  exit(1);}
	if (ff>1)  {printf ("ERROR because F>1\n");  exit(1);}
	
	
	temp=F(10, c1, c2, Lmin, Lmax, m);
	/*printf ("%f\n", ff);*/
	if (ff<temp)  {printf ("d > 10.0\n");  exit (1);}
	
	
	
	
		for (x=0; x<10.01; x+=0.001)  
		{
			f=F(x, c1, c2, Lmin, Lmax, m);
			if (f<ff) 
			{
				temp=x;
				/*printf ("d=%f\n", temp);*/
				break;
			}
		}
		
		for (x=temp-0.0011-0.0000025; ; x+=0.000005)
		{
			f=F(x, c1, c2, Lmin, Lmax, m);
			if (f<ff) 
			{
				temp=x;
				printf ("d = %f\n", 2.0*(temp-0.0000025));
				break;
			}
		}
		
	
	return 1;
}